/*
 * Copyright (c) 2013 - 2016 TDP Ltd All Rights Reserved.
 * TDP Ltd grants permission, free of charge, to any person obtaining copies
 * of this software and its associated documentation files (the "Software"),
 * to deal in the Software without restriction, including to use, copy, adapt,
 * publish, distribute, display, perform, sublicense, and sell copies of the
 * Software, subject to the following condition: You must include the above
 * copyright notice and this permission notice in all full or partial copies
 * of the Software.
 * TDP LTD PROVIDES THE SOFTWARE "AS IS," WITHOUT ANY EXPRESS OR IMPLIED WARRANTY,
 * INCLUDING WITHOUT THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, AND NON-INFRINGMENT. TDP LTD, THE AUTHORS OF THE SOFTWARE,
 * AND THE OWNERS OF COPYRIGHT IN THE SOFTWARE ARE NOT LIABLE FOR ANY CLAIM, DAMAGES,
 * OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT, OR OTHERWISE, ARISING
 * FROM, OUT OF, OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */
package cz.tdp.kshield.client;

import java.io.Serializable;


/**
 * This class represents KShield client message data
 */
public class ClientMessage implements Serializable
{
  private static final long serialVersionUID = 1558718065109210827L;

  private final String id;
  private final String from;
  private final String to;
  private final String message;
  
  
  /**
   * @param from
   * @param to
   * @param message
   */
  public ClientMessage(String from, String to, String message) {
    this(null, from, to, message);
  }
  
  public ClientMessage(String id, String from, String to, String message) {
    this.id = id;
    this.from = from;
    this.to = to;
    this.message = message;
  }


  public String toJSON() {
    final StringBuilder json = new StringBuilder(200);
    
    JSONUtil.startObject(json);
    if (id != null && !id.isEmpty()) {
      JSONUtil.appendProperty(json, "id", id);
    }
    JSONUtil.appendProperty(json, "from", from);
    JSONUtil.appendProperty(json, "to", to);
    JSONUtil.appendProperty(json, "message", message);
    JSONUtil.endObject(json);
    
    return json.toString();
  }
}
