/*
 * Copyright (c) 2013 - 2016 TDP Ltd All Rights Reserved.
 * TDP Ltd grants permission, free of charge, to any person obtaining copies
 * of this software and its associated documentation files (the "Software"),
 * to deal in the Software without restriction, including to use, copy, adapt,
 * publish, distribute, display, perform, sublicense, and sell copies of the
 * Software, subject to the following condition: You must include the above
 * copyright notice and this permission notice in all full or partial copies
 * of the Software.
 * 
 * TDP LTD PROVIDES THE SOFTWARE "AS IS," WITHOUT ANY EXPRESS OR IMPLIED WARRANTY,
 * INCLUDING WITHOUT THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, AND NON-INFRINGMENT. TDP LTD, THE AUTHORS OF THE SOFTWARE,
 * AND THE OWNERS OF COPYRIGHT IN THE SOFTWARE ARE NOT LIABLE FOR ANY CLAIM, DAMAGES,
 * OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT, OR OTHERWISE, ARISING
 * FROM, OUT OF, OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */
package cz.tdp.kshield.example;

import cz.tdp.kshield.client.KShieldClient;
import cz.tdp.kshield.client.KShieldClientException;
import cz.tdp.kshield.client.UserInfo;

//SONAR-IGNORE-FILE

/**
 * Low level usage of KShieldClient.<br/>
 * It is recommended to use AuthenticationService instead of KShieldClient, but in certain use cases is possible to use KShieldClient directly<br/>
 * KShieldClient doesn't depend on Servlet container.
 * <br/>
 * @see cz.tdp.kshield.integration.SimpleAuthenticationServiceImpl
 */
public class KShieldClientDemo
{
  public static void main(String[] args) {
    // URL of KeyShield SSO server
    String serverURL = "http://192.168.0.42:8485";
    
    // IP address of user
    String ipAddress = "192.168.100.42";
    
    // get user for given IP address
    try {
      final UserInfo user = new KShieldClient(serverURL).getUserByIP(ipAddress);
      
      if(user != null) {
        System.out.print("authenticated user: " + user.getUsername());
      }
      else {
        System.out.print("No user authenticated at: "+ipAddress);
      }
    }
    catch (KShieldClientException e) {
      System.out.print("Authentication failed: " + e.getMessage());
    }
  }
}
