package cz.tdp.kshield.notification;

import javax.websocket.EndpointConfig;
import javax.websocket.OnClose;
import javax.websocket.OnError;
import javax.websocket.OnMessage;
import javax.websocket.OnOpen;
import javax.websocket.RemoteEndpoint;
import javax.websocket.Session;

/**
 * Implementation of WebSocket Endpoint. You must provide access to KShieldAuthManager instance
 */
public abstract class AbstractKShieldEndpoint extends AbstractWebSocketEndpoint
{
  private RemoteEndpoint.Async remote;
  
  @OnOpen
  public void onOpen(Session session, EndpointConfig config) {
    onOpenImpl();
    
    remote = session.getAsyncRemote();
  }

  @OnClose
  public void onClose(Session session, EndpointConfig config) {
    onCloseImpl();
  }
  
  @OnError
  public void onError(Session session, Throwable e) {
    onErrorImpl(e);
  }

  @OnMessage
  public String onMessage(String message, Session session) {
    return onMessageImpl(message);
  }
  
  @Override
  protected void send(String message) {
    if (remote != null) {
      remote.sendText(message);
    }
  }
  
  @Override
  protected void reset() {
    remote = null;
    
    super.reset();
  }
}